<template>
	<v-form ref="form" v-model="isFormValid" @submit.prevent="handleSubmit">
		<v-dialog v-model="isCreateGroupOpen" max-width="50em" v-bind="$attrs">
			<group-create-form @cancel="cancelCreateGroup" @submitSuccess="handleGroupCreateSuccess"> </group-create-form>
		</v-dialog>
		<v-card>
			<v-card-text class="form-content">
				<v-text-field
					label="Name"
					v-model="name"
					:rules="[isNotEmpty('Name is required.'), hasMinimumLength(1, 'Name must be at least 1 character long.')]"
					validate-on-blur
					hint="Required *"
					persistent-hint
				/>
				<v-text-field label="Producer name" v-model="producerName" />
				<v-select
					label="Group"
					v-model="group"
					:items="groups"
					:item-text="(group) => `${group.name} - ${group.path}`"
					item-value="id"
					no-data-text="You are not a member of any groups."
					:loading="groupsAreLoading"
					:disabled="groupsAreLoading"
					:rules="[isNotEmpty('Group is required.')]"
					hint="Required *"
					persistent-hint
				>
					<template v-slot:prepend-item>
						<v-list-item ripple @mousedown.prevent @click="openCreateGroup">
							<v-list-item-content style="cursor: pointer">
								<v-list-item-title class="blue--text"> Add group... </v-list-item-title>
							</v-list-item-content>
						</v-list-item>
					</template>
				</v-select>
				<address-form v-model="address" />
				<contact-points-form :value="contactPoints" />
			</v-card-text>

			<v-card-actions class="px-4 pb-5 d-flex flex-wrap justify-end">
				<v-btn
					v-if="cancelButton"
					class="px-4"
					:class="{ 'ml-auto': $vuetify.breakpoint.smAndDown }"
					@click="$emit('cancel')"
					depressed
					rounded
				>
					{{ cancelButton }}
				</v-btn>
				<v-btn
					type="submit"
					class="px-4"
					:class="{ 'ml-auto': $vuetify.breakpoint.smAndDown && !cancelButton }"
					color="primary"
					depressed
					rounded
					>Next</v-btn
				>
			</v-card-actions>
		</v-card>
	</v-form>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import { useGroups } from '@/store/modules/group';
import { Address, ContactPoint, Field, Group, ResourceMeta } from '@/store/types';
import { hasMinimumLength, isNotEmpty } from '@/utils/rules';
import GroupCreateForm from '../../group/GroupCreateForm.vue';
import AddressForm from '../FieldEdit/AddressForm.vue';
import ContactPointsForm from '../FieldEdit/ContactPointsForm.vue';

export default defineComponent({
	components: { AddressForm, ContactPointsForm, GroupCreateForm },
	emits: ['submit', 'cancel'],
	props: {
		cancelButton: {
			type: String,
		},
	},
	setup(props, { root, emit }) {
		const isFormValid = ref<boolean>(false);
		const name = ref<string>('');
		const producerName = ref<string>('');
		const group = ref<string>('');
		const address = ref<Address>();
		const contactPoints = ref<Array<ContactPoint>>([]);
		const isCreateGroupOpen = ref<boolean>(false);
		const form = ref();

		const { isLoading: groupsAreLoading, groups } = useGroups(root.$store);

		const field = computed<Partial<Field>>(() => ({
			name: name.value,
			producerName: producerName.value,
			address: address.value,
			contactPoints: contactPoints.value,
			meta: {
				groupId: group.value,
			} as ResourceMeta,
		}));

		const handleSubmit = async () => {
			form.value.validate();

			if (!isFormValid.value) {
				return;
			}

			emit('submit', field.value);
		};

		const openCreateGroup = () => {
			isCreateGroupOpen.value = true;
		};

		const cancelCreateGroup = () => {
			isCreateGroupOpen.value = false;
		};

		const handleGroupCreateSuccess = async (createdGroup: Group) => {
			root.$store.dispatch('groups/getGroups');
			isCreateGroupOpen.value = false;
			group.value = createdGroup.id;
		};

		return {
			isFormValid,
			name,
			producerName,
			group,
			address,
			contactPoints,
			groupsAreLoading,
			groups,
			handleSubmit,
			hasMinimumLength,
			isNotEmpty,
			isCreateGroupOpen,
			openCreateGroup,
			cancelCreateGroup,
			handleGroupCreateSuccess,
			form,
		};
	},
});
</script>

<style lang="scss">
.form-content .v-input.v-text-field {
	margin-top: 8px;
}
</style>
